'Andrew Shelkovenko
'diakin@narod.ru
'03\2005
'===============================================================================
'Taj Morton original RapidQ functions ported to FreeBasic
'===============================================================================

'===============================================================================
'# GetPATH : Returns file path (without file name)
Function GetPath (fullname as string) as string
GetPath = left$(fullname, rinstr(,fullname, "\"))
end function

'===============================================================================
'# GetFILENAME : Returns file name (without path)
Function GetFileName (fullname as string) as string
GetFileName= right$(fullname, len(fullname) - rinstr(,fullname, "\"))
end function

'===============================================================================
'# GetFILEEXT : Returns file extension (like ".exe", ".html" etc.)
Function GetFileExt (fullname as string) as string
if instr(fullname,".")=0 then 
	GetFileExt  =""
else
	GetFileExt  = right$(fullname, len(fullname) - rinstr(,fullname, ".") + 1)
end if
end function

'===============================================================================
'# FILENAMENOEXT : Returns file name without extension
function GetFileNameNoExt(fullname as string) as string

fullname1$ = right$(fullname, len(fullname) - rinstr(,fullname, "\"))
GetFileNameNoExt = left$(fullname1$, rinstr(,fullname1$, ".") - 1)
end function

'===============================================================================
'# FULLPATHNOEXT : Returns full path without file extension
function GetFullPathNoExt(fullname as string) as string
GetFullPathNoExt = left$(fullname, rinstr(,fullname, ".") - 1)
end function

'===============================================================================
'# SetPATH : Set file path (without file name)
Function SetPath (fullname as string, newPath  as string) as long
if right$(newPath,1)<>"\" then newPath=newPath+"\"
fullname=newPath+getfilename(fullname)
end function

'===============================================================================
'# SetFILENAME : Set file name with old path
Function SetFileName (fullname as string, Newname as string) as integer

fullname=GetPath (fullname)+Newname

end function

'===============================================================================
'# SetFILEEXT : Set file extension (like ".exe", ".html" etc.)
Function SetFileExt (fullname as string,  Newext as string) as integer
fullname=GetFullPathNoExt(fullname)+Newext
end function





'===============================================================================
'# C_Style : Returns "slashed" path from a "backslashed" one
function C_Style (fullname as string) as string
fullname1$ = replacesubstr$(fullname, "\\", "\")
C_Style = replacesubstr$(fullname1$, "\", "/")
end function

'*********************'
function fileexists (filename as string) as byte
if dir$(filename, 0)<>"" then fileexists=1 else fileexists=0
end function   

'*********************'
FUNCTION LoadString(FName as STRING  ) AS string
dim sptr as byte ptr 
dim nptr as byte ptr 

f = freefile 
open FName for input as #f 
fsize=lof(f)
close #f 

dim nString as string            
dim inarray(0 to fsize) as byte

nString=string$(fsize,"-")
sptr = strptr(nString)

nptr=@inarray(0)
	#f = freefile
	open fname for binary as #f
	get #f, , inarray()
	close #f 

nString=*nptr

loadString=nString
end function   

'*********************'
FUNCTION SaveString(ss as STRING ,FileName as STRING  ) AS integer
end function   

'*********************'
FUNCTION FileSize(FileName as STRING  ) AS integer
f = freefile 
open FileName for input as #f 
filesize=lof(f)
close #f 

end function   

'************************
function  loadfromfile (fname as string, linetb() as string ) as integer 
   dim f as integer 
   dim lines as integer, l as integer 
   on local error goto errhnd 
   lines = 20000                        '' initial lines 
   redim linetb(0 to lines-1) as string 
   f = freefile    
   open fname for input as #f 
   l = 0 
   do until( eof( f ) ) 
         if( l >= lines ) then 
            lines =lines+ lines \ 2 
            redim preserve linetb(0 to lines-1) as string 
         end if 
          
         line input #f, linetb(l) 
         l =l+ 1 
   loop 
    
   close #f 
    
   loadfromfile = l 
   exit function 
    
errhnd: 
   loadfromfile = 0 
end function

